import React, { useMemo } from 'react';
import { createForm } from '@formily/core';
import { Form } from '@formily/antd';
import { observer } from '@formily/react';
import { requestIdle } from '@designable/shared';
import { useSelection, useTree, usePrefix, IconWidget } from '@designable/react';
import { SchemaField } from './SchemaField';
import { SettingsFormContext } from './context';
import { useLocales } from './effects';
import { Empty } from 'antd';
import cls from 'classnames';
import './styles.less';
var useSelected = function () {
    var selection = useSelection();
    return (selection === null || selection === void 0 ? void 0 : selection.selected) || [];
};
var useCurrentNode = function () {
    var _a;
    var selected = useSelected();
    var tree = useTree();
    return (_a = tree === null || tree === void 0 ? void 0 : tree.findById) === null || _a === void 0 ? void 0 : _a.call(tree, selected[0]);
};
export var SettingsForm = observer(function (props) {
    var _a;
    var node = useCurrentNode();
    var selected = useSelected();
    var prefix = usePrefix('settings-form');
    var form = useMemo(function () {
        return createForm({
            values: node === null || node === void 0 ? void 0 : node.props,
            effects: function () {
                useLocales();
            },
        });
    }, [node, (_a = node === null || node === void 0 ? void 0 : node.designerProps) === null || _a === void 0 ? void 0 : _a.propsSchema]);
    var render = function () {
        var _a;
        if (node && ((_a = node.designerProps) === null || _a === void 0 ? void 0 : _a.propsSchema) && selected.length === 1) {
            return (React.createElement("div", { className: cls(prefix, props.className), style: props.style },
                React.createElement(SettingsFormContext.Provider, { value: props },
                    React.createElement(Form, { form: form, colon: false, labelWidth: 120, labelAlign: "left", wrapperAlign: "right", feedbackLayout: "none" },
                        React.createElement(SchemaField, { schema: node.designerProps.propsSchema })))));
        }
        return (React.createElement("div", { className: prefix + '-empty' },
            React.createElement(Empty, null)));
    };
    return React.createElement(IconWidget.Provider, { tooltip: true }, render());
}, {
    scheduler: requestIdle,
});
