var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import React, { Fragment, useState, useRef } from 'react';
import { FormItem } from '@formily/antd';
import { useField } from '@formily/react';
import { IconWidget, usePrefix } from '@designable/react';
import cls from 'classnames';
import './styles.less';
var ExpandedMap = new Map();
export var FoldItem = function (_a) {
    var className = _a.className, style = _a.style, children = _a.children, props = __rest(_a, ["className", "style", "children"]);
    var prefix = usePrefix('fold-item');
    var field = useField();
    var _b = __read(useState(ExpandedMap.get(field.address.toString())), 2), expand = _b[0], setExpand = _b[1];
    var slots = useRef({ base: null, extra: null });
    React.Children.forEach(children, function (node) {
        var _a, _b;
        if (React.isValidElement(node)) {
            if (((_a = node === null || node === void 0 ? void 0 : node['type']) === null || _a === void 0 ? void 0 : _a['displayName']) === 'FoldItem.Base') {
                slots.current.base = node['props'].children;
            }
            if (((_b = node === null || node === void 0 ? void 0 : node['type']) === null || _b === void 0 ? void 0 : _b['displayName']) === 'FoldItem.Extra') {
                slots.current.extra = node['props'].children;
            }
        }
    });
    return (React.createElement("div", { className: cls(prefix, className) },
        React.createElement("div", { className: prefix + '-base', onClick: function () {
                var newExpaned = !expand;
                setExpand(newExpaned);
                ExpandedMap.set(field.address.toString(), newExpaned);
            } },
            React.createElement(FormItem.BaseItem, __assign({}, props, { label: React.createElement("span", { className: cls(prefix + '-title', {
                        expand: expand,
                    }) },
                    slots.current.extra && React.createElement(IconWidget, { infer: "Expand", size: 10 }),
                    props.label) }),
                React.createElement("div", { style: { width: '100%' }, onClick: function (e) {
                        e.stopPropagation();
                    } }, slots.current.base))),
        expand && slots.current.extra && (React.createElement("div", { className: prefix + '-extra' }, slots.current.extra))));
};
var Base = function () {
    return React.createElement(Fragment, null);
};
Base.displayName = 'FoldItem.Base';
var Extra = function () {
    return React.createElement(Fragment, null);
};
Extra.displayName = 'FoldItem.Extra';
FoldItem.Base = Base;
FoldItem.Extra = Extra;
