"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SettingsForm = void 0;
var react_1 = __importStar(require("react"));
var core_1 = require("@formily/core");
var antd_1 = require("@formily/antd");
var react_2 = require("@formily/react");
var shared_1 = require("@designable/shared");
var react_3 = require("@designable/react");
var SchemaField_1 = require("./SchemaField");
var context_1 = require("./context");
var effects_1 = require("./effects");
var antd_2 = require("antd");
var classnames_1 = __importDefault(require("classnames"));
require("./styles.less");
var useSelected = function () {
    var selection = react_3.useSelection();
    return (selection === null || selection === void 0 ? void 0 : selection.selected) || [];
};
var useCurrentNode = function () {
    var _a;
    var selected = useSelected();
    var tree = react_3.useTree();
    return (_a = tree === null || tree === void 0 ? void 0 : tree.findById) === null || _a === void 0 ? void 0 : _a.call(tree, selected[0]);
};
exports.SettingsForm = react_2.observer(function (props) {
    var _a;
    var node = useCurrentNode();
    var selected = useSelected();
    var prefix = react_3.usePrefix('settings-form');
    var form = react_1.useMemo(function () {
        return core_1.createForm({
            values: node === null || node === void 0 ? void 0 : node.props,
            effects: function () {
                effects_1.useLocales();
            },
        });
    }, [node, (_a = node === null || node === void 0 ? void 0 : node.designerProps) === null || _a === void 0 ? void 0 : _a.propsSchema]);
    var render = function () {
        var _a;
        if (node && ((_a = node.designerProps) === null || _a === void 0 ? void 0 : _a.propsSchema) && selected.length === 1) {
            return (react_1.default.createElement("div", { className: classnames_1.default(prefix, props.className), style: props.style },
                react_1.default.createElement(context_1.SettingsFormContext.Provider, { value: props },
                    react_1.default.createElement(antd_1.Form, { form: form, colon: false, labelWidth: 120, labelAlign: "left", wrapperAlign: "right", feedbackLayout: "none" },
                        react_1.default.createElement(SchemaField_1.SchemaField, { schema: node.designerProps.propsSchema })))));
        }
        return (react_1.default.createElement("div", { className: prefix + '-empty' },
            react_1.default.createElement(antd_2.Empty, null)));
    };
    return react_1.default.createElement(react_3.IconWidget.Provider, { tooltip: true }, render());
}, {
    scheduler: shared_1.requestIdle,
});
